from browser import document, window, timer
import sys
import traceback
import imprimante
import time

jq = window.jQuery
interval = None
ns = None

jq('#printer-set-pla').click(lambda: exec("fixer_temperatures_pla()", ns) if ns else None)
jq('#printer-set-abs').click(lambda: exec("fixer_temperatures_abs()", ns) if ns else None)
jq('#printer-start').click(lambda: exec("demarrer_impression()", ns) if ns else None)

def clearConsole():
    document["console"].value = ""

def run(*args):
    global interval, ns
    stop()
    clearConsole()
    imprimante.reset()
    try:
        ns = {'__name__':'__main__'}
        window.headTempTimeSeries.clear();
        window.bedTempTimeSeries.clear();
        window.chart.start()
        exec(window.editor.getValue(), ns)
        interval = timer.set_interval(run_loop, 100);
    except Exception as exc:
        traceback.print_exc(file=sys.stderr)

def run_loop():
    tt = imprimante.lire_temperature_cible()
    ct = imprimante.lire_temperature()
    window.headTempTimeSeries.append(int(time.time() * 1000), ct[0]);
    window.bedTempTimeSeries.append(int(time.time() * 1000), ct[1]);
    jq("#printer_set_temp_head").html(round(tt[0],1))
    jq("#printer_set_temp_bed").html(round(tt[1],1))
    jq("#printer_temp_head").html(round(ct[0],1))
    jq("#printer_temp_bed").html(round(ct[1],1))
    jq("#printer_heating").html("Oui" if imprimante.chauffage_en_cours() else "Non")
    jq("#printer_printing").html("Oui" if imprimante.impression_en_cours() else "Non")
    try:
        exec("loop()", ns)
    except Exception as exc:
        traceback.print_exc(file=sys.stderr)

def stop(*args):
    global interval, ns
    window.chart.stop()
    if interval:
        timer.clear_interval(interval)
        interval = None
    del ns

jq('#run').click(run)

class cOutput:
    encoding = 'utf-8'

    def __init__(self):
        self.cons = document["console"]
        self.buf = ''

    def write(self, data):
        self.buf += str(data)

    def flush(self):
        self.cons.value += self.buf
        self.buf = ''
        self.cons.scrollTop = self.cons.scrollHeight;

    def __len__(self):
        return len(self.buf)

cOut = cOutput()
sys.stdout = cOut
sys.stderr = cOut

info = sys.implementation.version
version = "Python %s.%s.%s on %s %s\n" % (
    info[0], info[1], info[2], window.navigator.appName, window.navigator.appVersion)
print(version)

jq('.btn').removeAttr('disabled')
window.run = run

run()